/*****************************************************
WinAVR  20100110

: Dpm_30
: 1.1
: 12.03.2011
:  ..
: 
:   

  	: ATtiny2313
  RC		: 8,000000 MHz

FuseH					: 0xD9
RSTDISBL				: 1
BODLEVEL				: 100
WDTON					: 1
SPIEN					: 0
EESAVE					: 1
DWEN					: 1

FuseL					: 0xE4
CKSEL					: 0100
SUT						: 10
CKOUT					: 1
CKDIV8					: 1
*****************************************************/

#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <util/delay.h>

typedef unsigned bit;
typedef unsigned char byte;
typedef unsigned int word;

//  
static EEMEM byte blk1[7]={5,1,62,56,0,0,0}; //  ,  ,    ,   ,      
static EEMEM word blk2[3]={990,10800,5000}; //  ,   ,    

volatile struct
	{
	bit nkn:1; //   
	bit okn:1; //   
	bit rvs:1; //   
	bit itr:1; //  
	} flg;

volatile byte idx_rej=0; //  

//  
word adc_cur(void); //    
void scn_knp(void); //   
void ust_obr(void); //      

ISR(WDT_OVERFLOW_vect)
	{
	flg.itr=1; //       
	}

word adc_cur(void) //    
    {
	byte clc_adc=128; //    
	word adc_tmp;
	OCR0A=clc_adc; //       
    while(clc_adc!=1) //     1    
        {
        clc_adc/=2; //   
        _delay_ms(5); //  5 
        if(bit_is_clear(ACSR,ACO)) OCR0A-=clc_adc; //           
        else OCR0A+=clc_adc; //           
        }
    adc_tmp=(word)OCR0A*196; //      
    adc_tmp=(adc_tmp-(eeprom_read_word(&blk2[2])*10-adc_tmp)/eeprom_read_word(&blk2[0])*(word)eeprom_read_byte(&blk1[3]))/(word)eeprom_read_byte(&blk1[2]); //   
    return adc_tmp; //   
	}

void scn_knp(void) //   
	{
	if((bit_is_set(PIND,PD0))&&(flg.nkn==0)&&(flg.okn==0)) flg.okn=1; //            
	else if((bit_is_clear(PIND,PD0))&&(flg.nkn==0)&&(flg.okn==1)) //    
		{
		flg.nkn=1; //    
		flg.okn=0; //    
		}
	else if((bit_is_clear(PIND,PD0))&&(flg.nkn==1)&&(flg.okn==0)) //         
		{
		flg.nkn=0; //    
		idx_rej++; //   
		if(idx_rej>2) idx_rej=0; //     2   
		}
	}

void ust_obr(void) //         
	{
	byte idx_tmp=0; //  
	byte clc_tmp=0;
	flg.rvs=0; //   
	idx_rej=0; //   
	OCR1AL=eeprom_read_byte(&blk1[0]); //     
	while(idx_tmp<4) //   20 
		{
		if(flg.rvs==0) PORTD&=~_BV(PD1); //      
		else PORTD|=_BV(PD1); //      
		while(clc_tmp<100) //   5 
			{
			scn_knp(); //  
			_delay_ms(50); //  50 
			if(idx_rej>0) //    
				{
				idx_rej=0; //   
				clc_tmp=0; //     
				idx_tmp=0; //     
				if((flg.rvs==0)&&(OCR1AL<255)) OCR1AL++; //      
				else if((flg.rvs==1)&&(OCR1AL>0)) OCR1AL--; //      
				}
			else clc_tmp++; //      
			}
		flg.rvs=~flg.rvs; //   
		idx_rej=0; //   
		clc_tmp=0; //    
		idx_tmp++; //      		
		}
	if(eeprom_read_byte(&blk1[0])!=OCR1AL) eeprom_write_byte(&blk1[0],OCR1AL); //       EEPROM
	idx_tmp=0; //  
	OCR0A=0; //   
	while(idx_tmp==0) //    
		{
		OCR0A++; //    
		_delay_ms(10); //     
		if(bit_is_clear(ACSR,ACO)) //     . 0
			{
			clc_tmp=0; //  
			while(clc_tmp<10) //   
				{
				if(bit_is_clear(ACSR,ACO)) //  . 0    
					{
					clc_tmp++;
					_delay_ms(10);
					if(clc_tmp==10) idx_tmp=OCR0A+2; //          
					}
				else clc_tmp=10;
				}
			}
		}
	eeprom_write_byte(&blk1[5],idx_tmp); //    
	while(OCR1AL<250) //      
        {
        OCR1AL+=5; //   
        _delay_ms(20); //    
        }
    _delay_ms(2000); //     
	eeprom_write_byte(&blk1[4],(adc_cur()+10)); //     
	eeprom_write_byte(&blk1[6],1); //    
	OCR1AL=0; //  
	OCR0A=0; //   
	}

int main(void)
{
//  
word clc_tim=0; //   
word cur_edv; //   
word pow_edv; //   

//  
PORTB=0x10;
DDRB=0x0C;
PORTD=0x3F;
DDRD=0x42;
DIDR=0x03;
TCCR0A=0x83;
TCCR0B=0x01;
TCCR1A=0x81;
TCCR1B=0x02;
OCR0A=0x00;
WDTCSR=0x00;
if((bit_is_clear(PIND,PD0))||(eeprom_read_byte(&blk1[6])==0)) ust_obr(); //                 
_delay_ms(1000); //  1 
flg.rvs=0; //    
flg.itr=0; //   
WDTCSR|=_BV(WDCE); //       
WDTCSR|=_BV(WDP1); //    64 
WDTCSR|=_BV(WDIE); //      
sei(); //   

while(1)
    {
	if(flg.itr==1) //    
		{
		flg.itr=0; //   
		scn_knp(); //  
		if(idx_rej==2) OCR1AL=0; //    2   
		else if((idx_rej!=2)&&(OCR1AL==0)&&(flg.rvs==0)) OCR1AL=eeprom_read_byte(&blk1[0]); //      2       
		else if((flg.rvs==0)&&(OCR1AL>0)) //   
			{
			if(OCR1AL==eeprom_read_byte(&blk1[0])) //    
				{
				if(OCR0A!=eeprom_read_byte(&blk1[5])) OCR0A=eeprom_read_byte(&blk1[5]); //    
				if(bit_is_set(ACSR,ACO)) OCR1AL+=10; //         
				else //    
					{
					clc_tim++; //   
        			if(clc_tim>940) //     940 ( 1 )
            			{
            			clc_tim=0; //   
						idx_rej=2; //    
						}
					}
				}
			else
				{
				if(clc_tim>0) clc_tim=0; //   
    			cur_edv=adc_cur(); //    
				pow_edv=((word)OCR1AL*105/99-cur_edv*eeprom_read_byte(&blk1[2])/1000)*(cur_edv/2)/5; //    
    			if((cur_edv<=eeprom_read_byte(&blk1[4]))&&(OCR1AL>eeprom_read_byte(&blk1[0]))) OCR1AL=0; //             
    			if((idx_rej==0)&&(OCR1AL>eeprom_read_byte(&blk1[0]))) //    25%     
        			{
        			if((pow_edv<(eeprom_read_word(&blk2[1])/4))&&(OCR1AL<251)) OCR1AL+=5; //     25%     
        			else if((pow_edv>(eeprom_read_word(&blk2[1])/4))&&(OCR1AL>eeprom_read_byte(&blk1[0]))) OCR1AL-=5; //     25%     
        			if((cur_edv>300)&&(eeprom_read_byte(&blk1[1])==1)) //    300 
						{
						OCR1AL=0; //  
						flg.rvs=1; //    
						}
        			}
    			else if((idx_rej==1)&&(OCR1AL>eeprom_read_byte(&blk1[0]))) //    100%     
        			{
        			if((pow_edv<eeprom_read_word(&blk2[1]))&&(OCR1AL<251)) OCR1AL+=5; //     100%     
        			else if((pow_edv>eeprom_read_word(&blk2[1]))&&(OCR1AL>eeprom_read_byte(&blk1[0]))) OCR1AL-=5; //     100%     
        			if((cur_edv>450)&&(eeprom_read_byte(&blk1[1])==1)) //    450 
						{
						OCR1AL=0; //  
						flg.rvs=1; //    
						}
        			}
				}
			}
		else if(flg.rvs==1)
			{
    		if(bit_is_clear(PORTD,PD6)) PORTD|=_BV(PD6); //       
			else
				{
    			if(OCR1AL<130) OCR1AL+=10; //     
				else
					{
    				OCR1AL=0; //  
    				PORTD&=~_BV(PD6); //   
					flg.rvs=0; //    
					}
				}
    		}
		if(bit_is_clear(PORTD,PD1)&&((idx_rej==0)||(idx_rej==2))) PORTD|=_BV(PD1); //     
    	else if(bit_is_set(PORTD,PD1)&&((idx_rej==0)||(idx_rej==1))) PORTD&=~_BV(PD1); //     
    	}
	}
}
